/** Esercitazione: test di uso degli iteratori su oggetti List (ArrayList, LinkedList) 
 *  Il programma calcola la somma di interi generati random sia mediante iteratori che
 *  mediante accesso diretto ai singoli elementi mediante il metodo get()
 *
 *  1) generazione random di liste di dimensione crescente (L massima dimensione)
 *  2) calcolo del tempo di esecuzione su pi liste generate
 *  3) confronto dei tempi di esecuzione
 *  Remark:
 *  The currentTimeMillis() method returns the current time in milliseconds
	"This method returns the difference, measured in milliseconds, between
	the current time and midnight, January 1, 1970 UTC(coordinated universal time)"
 */

import java.util.*;

public class RandomList3 {

	public static void main(String[] args) {		
			     new RandomList3().run();
	} // method main


	public void run(){
		
		List<Integer> randList = new LinkedList<Integer>();
		List<Integer> randArray = new ArrayList<Integer>();
		
		final int L = 1000000;
		long somma = 0; //unsigned 64-bit long in [0, 2^64 - 1] 			      
		Random r = new Random();
		
      	double startTime, endTime; // tempi di esecuzione totale in ms
      	double time_getL=0; 
      	double time_itrL=0;
      	double time_getA=0; 
      	double time_itrA=0;

		System.out.println("L\t itrL\t itrA\t getL\t getA");
		
      	for (int len = 1000; len<= L; len = len*10) {
      	randList.clear();
      	randArray.clear();    	
		      
      	// Insert len random integers, in the range 0...99, into randList:
      	for (int i = 0; i < len; i++) {
      		int randInt = r.nextInt(100);
      		randList.add (randInt); // insertion
      		randArray.add(randInt);
      	}
		
		somma = 0;
      	//calcola la somma mediante iterazione standard
		startTime = System.currentTimeMillis(); 
		for (Integer x: randList) somma += x;
		endTime = System.currentTimeMillis();
		time_itrL = endTime - startTime;  //per avere in sec /1000
		
		somma = 0;
		startTime = System.currentTimeMillis(); //The currentTimeMillis() method returns the current time in milliseconds.
		for (Integer x: randArray) somma += x;
		endTime = System.currentTimeMillis();
		time_itrA = endTime - startTime; 
		
		//calcola la somma mediante accesso diretto alle singole componenti
		somma = 0;		
		startTime = System.currentTimeMillis(); //The currentTimeMillis() method returns the current time in milliseconds.
		for (int i = 0; i < len; i++) somma += randList.get(i);
		endTime = System.currentTimeMillis();
		time_getL = endTime - startTime; 
		
		somma = 0;		
		startTime = System.currentTimeMillis(); //The currentTimeMillis() method returns the current time in milliseconds.
		for (int i = 0; i < len; i++) somma += randArray.get(i);
		endTime = System.currentTimeMillis();
		time_getA = endTime - startTime; 

		System.out.println("Somma = " + somma);
		System.out.println(len + "\t" + time_itrL + "\t" + time_itrA  + "\t" + time_getL  + "\t" + time_getA + "\t ms");

      	}//end-for;
      	
      	System.out.println("end");

	} // method run

} // class RandomList3



